VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private firstname As String
Private lastname As String
Private jersey As Byte
Private feet As Byte
Private inch As Byte
Private weight As Integer
Private pos As Byte
Private fg As Integer
Private ft As Integer
Private threePt As Integer

Private race_nes As Byte

Private rspeed As Byte
Private jump As Byte
Private steal As Byte
Private block As Byte
Private shoot As Byte
Private stam As Byte
Private unkByte As Byte

Private dataPtr As Long

Option Explicit



'_________________________________________________________________________________________________________________
'
'   name functions
'

Public Function setFirst(ByVal first As String)
    firstname = first
End Function
Public Function setLast(ByVal last As String)
    lastname = last
End Function


Public Function getFirst() As String
    getFirst = firstname
End Function
Public Function getLast() As String
    getLast = lastname
End Function
Public Function getFullname() As String
    getFullname = firstname + " " + lastname
End Function



'_________________________________________________________________________________________________________________
'
'   jersey/height/weight
'

Public Function setJersey(ByVal number As Byte)
    jersey = number
End Function
Public Function setFeet(ByVal ft As Byte)
    feet = ft
End Function
Public Function setInch(ByVal i As Byte)
    inch = i
End Function
Public Function setWeight(ByVal wt As Integer)
    weight = wt
End Function


Public Function getJersey() As Byte
    getJersey = jersey
End Function
Public Function getFeet() As Byte
    getFeet = feet
End Function
Public Function getInch() As Byte
    getInch = inch
End Function
Public Function getWeight() As Integer
    getWeight = weight
End Function



'_________________________________________________________________________________________________________________
'
'   position/shooting percentages
'

Public Function setPosition(ByVal position As Byte)
    pos = position
End Function
Public Function setFGpercent(ByVal percent As Integer)
    fg = percent
End Function
Public Function setFTpercent(ByVal percent As Integer)
    ft = percent
End Function
Public Function set3PTpercent(ByVal percent As Integer)
    threePt = percent
End Function

Public Function getPosition()
    getPosition = pos
End Function
Public Function getFGpercent() As Integer
    getFGpercent = fg
End Function
Public Function getFTpercent() As Integer
    getFTpercent = ft
End Function
Public Function get3PTpercent() As Integer
    get3PTpercent = threePt
End Function



'_________________________________________________________________________________________________________________
'
'   attributes
'

Public Function setRunSpeed(ByVal RS As Byte)
    rspeed = RS
End Function
Public Function setJump(ByVal jmp As Byte)
    jump = jmp
End Function
Public Function setSteal(ByVal stl As Byte)
    steal = stl
End Function
Public Function setBlock(ByVal blk As Byte)
    block = blk
End Function
Public Function setShotRange(ByVal sr As Byte)
    shoot = sr
End Function
Public Function setStamina(ByVal stma As Byte)
    stam = stma
End Function
Public Function setUnknownByte(ByVal unk As Byte)
    unkByte = unk
End Function

Public Function getRunSpeed() As Byte
    getRunSpeed = rspeed
End Function
Public Function getJump() As Byte
    getJump = jump
End Function
Public Function getSteal() As Byte
    getSteal = steal
End Function
Public Function getBlock() As Byte
    getBlock = (block And &HF)
End Function
Public Function getShotRange() As Byte
    getShotRange = (shoot And &H7F)
End Function
Public Function getStamina() As Byte
    getStamina = stam
End Function
Public Function getUnknownByte() As Byte
    getUnknownByte = unkByte
End Function

' r sr:       r.Print .ssss
'             |||| ++++-shot range (range: $0-$A)
'             |||+------UNUSED
'             ||+-------???
'             |+--------UNUSED
'             +---------race (0=light, 1=dark) (NES version only!)
Public Function getRaceNES() As Byte
    getRaceNES = (shoot And &H80)
End Function
Public Function getRaceSNES() As Byte
    ' ...coming soon...
End Function
'F b:        ffff bbbb
'            |||| ++++-blocking (range: $0 - $C)
'            ++++------face index (NES version only!)
'
'            actual b = (b.LN * 8)
'            face is used with race (see R.bit7, NES version only!)
Public Function getFaceNES() As Integer
    getFaceNES = (block And &HF0)
End Function
Public Function getFaceSNES() As Byte
    ' ...coming soon...
End Function



Public Function setDataPtr(ByVal addr As Long)
    dataPtr = addr
End Function
Public Function getDataPtr() As Long
    getDataPtr = dataPtr
End Function



'_________________________________________________________________________________________________________________
'
'   converted attributes
'
'
'-----------------------------------
' Key: RS = Running Speed
'      J = Jumping
'      SR = Shooting Range
'      S = Stanima
'      ST = Stealing
'      B = Blocking
'      R = Race
'      F = Face
'      HN = High Nibble
'      LN = Low Nibble
'-----------------------------------
' RS:     range:   $00=min, $1F=max
' actual RS = (RS.HN * $28) + (RS.LN * 4)
Public Function getConvRunSpeed() As Integer
    getConvRunSpeed = (((rspeed And &HF0) / &H10) * &H28) + ((rspeed And &HF) * 4)
End Function

' JUMP:       range:   $90=min, $D3=max
' actual J  = (J - $90) + ((J - $90) / 2)
Public Function getConvJump() As Integer
    getConvJump = (jump - &H90&) + ((jump - &H90&) / 2)
End Function

' R+SR
' r... ssss
' |||| ++++-shot range (range: $0-$A)
' |||+------UNUSED
' ||+-------???
' |+--------UNUSED
' +---------race (0=light, 1=dark) (NES version only!)
' actual sr = (sr.LN * 2) + (sr.LN * 8)
Public Function getConvShotRange() As Integer
    getConvShotRange = ((shoot And &HF) * 2) + ((shoot And &HF) * 8)
End Function

' S:      range: $00=min, $64=max
' actual S = S
Public Function getConvStamina() As Integer
    getConvStamina = stam + 1
End Function

' ST:     range: $00=min, $C8=max
' actual ST = (ST / 2)
Public Function getConvSteal() As Integer
    getConvSteal = (steal / 2)
End Function

' F B:        ffff bbbb
' |||| ++++-blocking (range: $0 - $C)
' ++++------face index (NES version only!)

' actual B = (B.LN * 8)
' face is used with race (see R.bit7, NES version only!)
Public Function getConvBlock() As Integer
    getConvBlock = ((block And &HF) * 8)
End Function





'_________________________________________________________________________________________________________________
'
'   inc/dec attributes
'

Public Function decRS()
    Dim temp As Integer
    temp = rspeed - 1
    If (temp < &H0) Then
        rspeed = &H0
    Else
        rspeed = temp
    End If
End Function
Public Function decJump()
    jump = jump - 1
    If (jump < &H90) Then
        jump = &H90
    End If
End Function
Public Function decSR()
    Dim temp As Integer
    temp = (shoot And &HF) - 1
    If (temp < &H0) Then
        temp = &H0
    End If
    shoot = (shoot And &H80) Or (temp And &HF)
End Function
Public Function decStam()
    Dim temp As Integer
    temp = stam - 1
    If (temp < &H0) Then
        stam = &H0
    Else
        stam = temp
    End If
End Function
Public Function decSteal()
    Dim temp As Integer
    temp = steal - 1
    If (temp < &H0) Then
        steal = &H0
    Else
        steal = temp
    End If
End Function
Public Function decBlock()
    Dim temp As Integer
    temp = (block And &HF) - 1
    If (temp < &H0) Then
        temp = &H0
    End If
    block = ((block And &HF0) Or (temp And &HF))
End Function

Public Function incRS()
    rspeed = rspeed + 1
    If (rspeed > &H1F) Then
        rspeed = &H1F
    End If
End Function
Public Function incJump()
    jump = jump + 1
    If (jump > &HD3) Then
        jump = &HD3
    End If
End Function
Public Function incSR()
    Dim temp As Integer
    temp = (shoot And &HF)
    temp = temp + 1
    If (temp > &HA) Then
        temp = &HA
    End If
    shoot = (shoot And &H80) Or (temp And &HF)
End Function
Public Function incStam()
    stam = stam + 1
    If (stam > &H63) Then
        stam = &H63
    End If
End Function
Public Function incSteal()
    steal = steal + 1
    If (steal > &HC8) Then
        steal = &HC8
    End If
End Function
Public Function incBlock()
    Dim temp As Integer
    temp = (block And &HF)
    temp = temp + 1
    If (temp > &HC) Then
        temp = &HC
    End If
    block = ((block And &HF0) Or (temp And &HF))
End Function




'_________________________________________________________________________________________________________________
'
'   file i/o
'
'     formats:
'
'       ------------------
'        player  (*.rpl")
'       ------------------
'
'         first=STRING
'         last=STRING
'         jersey=NUMBER
'         feet=NUMBER
'         inch=NUMBER
'         pos=NUMBER
'         fg=NUMBER
'         ft=NUMBER
'         threept=NUMBER
'         rspeed=NUMBER
'         jump=NUMBER
'         steal=NUMBER
'         block=NUMBER
'         shoot=NUMBER
'         stam=NUMBER
'


Public Function export(ByVal filename As String) As Integer

    On Error GoTo err

    Dim nFileNum As Integer
    nFileNum = FreeFile

    Open filename For Output As nFileNum
        Call writeToFile(nFileNum)
    Close nFileNum

    export = 0
    Exit Function

err:
    export = 1
    Close nFileNum
End Function

Public Function writeToFile(ByVal nFileNum As Integer)
        Print #nFileNum, "first=" & UCase(firstname)
        Print #nFileNum, "last=" & UCase(lastname)
        Print #nFileNum, "jersey=" & jersey
        Print #nFileNum, "feet=" & feet
        Print #nFileNum, "inch=" & inch
        Print #nFileNum, "weight=" & weight
        Print #nFileNum, "pos=" & pos
        Print #nFileNum, "fg=" & fg
        Print #nFileNum, "ft=" & ft
        Print #nFileNum, "threept=" & threePt
        
        Print #nFileNum, "rspeed=" & rspeed
        Print #nFileNum, "jump=" & jump
        Print #nFileNum, "steal=" & steal
        Print #nFileNum, "block=" & block
        Print #nFileNum, "shoot=" & shoot
        Print #nFileNum, "stam=" & stam
End Function

Public Function import(ByVal filename As String) As Integer

    On Error GoTo err

    Dim nFileNum As Integer, instring As String, tempstring As String
    nFileNum = FreeFile
    
    Call initPlayer             ' reset player to defaults (in case of older version of *.rpl)
    Open filename For Input As nFileNum
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, instring
            Call processImportString(instring)
        Loop
    Close nFileNum

    import = 0
    Exit Function

err:
    import = 1
    Close nFileNum
End Function

Public Function processImportString(ByVal instring As String)
            If (InStr(instring, "first=") <> 0) Then
                firstname = UCase(Right(instring, Len(instring) - 6))
            ElseIf (InStr(instring, "last=") <> 0) Then
                lastname = UCase(Right(instring, Len(instring) - 5))
            ElseIf (InStr(instring, "jersey=") <> 0) Then
                jersey = Right(instring, Len(instring) - 7)
            ElseIf (InStr(instring, "feet=") <> 0) Then
                feet = Right(instring, Len(instring) - 5)
            ElseIf (InStr(instring, "inch=") <> 0) Then
                inch = Right(instring, Len(instring) - 5)
            ElseIf (InStr(instring, "weight=") <> 0) Then
                weight = Right(instring, Len(instring) - 7)
            ElseIf (InStr(instring, "pos=") <> 0) Then
                pos = Right(instring, Len(instring) - 4)
            ElseIf (InStr(instring, "fg=") <> 0) Then
                fg = Right(instring, Len(instring) - 3)
            ElseIf (InStr(instring, "ft=") <> 0) Then
                ft = Right(instring, Len(instring) - 3)
            ElseIf (InStr(instring, "threept=") <> 0) Then
                threePt = Right(instring, Len(instring) - 8)
            ElseIf (InStr(instring, "rspeed=") <> 0) Then
                rspeed = Right(instring, Len(instring) - 7)
            ElseIf (InStr(instring, "jump=") <> 0) Then
                jump = Right(instring, Len(instring) - 5)
            ElseIf (InStr(instring, "steal=") <> 0) Then
                steal = Right(instring, Len(instring) - 6)
            ElseIf (InStr(instring, "block=") <> 0) Then
                block = Right(instring, Len(instring) - 6)
            ElseIf (InStr(instring, "shoot=") <> 0) Then
                shoot = Right(instring, Len(instring) - 6)
            ElseIf (InStr(instring, "stam=") <> 0) Then
                stam = Right(instring, Len(instring) - 5)
            End If
End Function

' returns an array of the attribute data
'  -ready to be written to rom()
Public Function getAttBytes() As Byte()
    Dim temp(6) As Byte
    temp(0) = rspeed
    temp(1) = jump
    temp(2) = steal
    temp(3) = block
    temp(4) = shoot
    temp(5) = stam
    temp(6) = unkByte
    getAttBytes = temp
End Function

' returns an array of all player data
'  -ready to be written to rom()
Public Function getDataArray() As Byte()

    Dim lenofdata As Integer
    lenofdata = (Len(firstname & " " & lastname) + 7)
   
    ReDim dataArray(lenofdata - 1) As Byte
    
    Dim temp() As Byte
    Dim i As Integer
    temp = StrConv(firstname, vbFromUnicode)
    For i = 0 To UBound(temp)
        dataArray(i) = temp(i)
    Next i
    dataArray(i) = &H20
    temp = StrConv(lastname, vbFromUnicode)
    For i = 0 To UBound(temp)
        dataArray(Len(firstname) + 1 + i) = temp(i)
    Next i
    temp = getDataBytes()
    For i = 0 To 6
        dataArray(lenofdata - 7 + i) = temp(i)
    Next i

    getDataArray = dataArray
End Function

' returns an array of player data (name not included)
'  -ready to be written to rom()
Private Function getDataBytes() As Byte()
        Dim temp(6) As Byte
        temp(0) = (pos Or &H80)
        temp(1) = Val("&H" & jersey)
        temp(2) = (((feet And &HF) * &H10) Or (inch And &HF))
        temp(3) = ((weight / 4) And &HFF)
        temp(4) = (fg / 4)
        temp(5) = (ft / 4)
        temp(6) = (threePt / 4)
        getDataBytes = temp
End Function

Public Function initPlayer()
    firstname = ""
    lastname = ""
    jersey = 0
    feet = 0
    inch = 0
    weight = 0
    pos = 0
    fg = 0
    ft = 0
    threePt = 0
    rspeed = 0
    jump = &H90
    steal = 0
    block = 0
    shoot = 0
    stam = 0
    dataPtr = -1
End Function
