VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private team(26) As New clsTeam     ' 0-26 objects
Private schedule(&H8A6 - 1) As Byte

Private east_allstars(1, 11) As Byte
Private west_allstars(1, 11) As Byte

Option Explicit




Public Function getTeamRef(ByVal teamnum As Integer) As clsTeam
    Set getTeamRef = team(teamnum)
End Function

Public Function getMatchupStr(ByVal gamenum As Integer) As String
    Dim home As Byte, away As Byte
    home = schedule(gamenum * 2) And &H1F
    away = schedule((gamenum * 2) + 1) And &H1F
    
    getMatchupStr = team(away).getAbrev() & " at " & team(home).getAbrev()
End Function

Public Function getMatchupBytes(ByVal gamenum As Integer) As Byte()
    Dim temp(1) As Byte
    temp(0) = schedule(gamenum * 2) And &H1F
    temp(1) = schedule((gamenum * 2) + 1) And &H1F
    getMatchupBytes = temp
End Function
Public Function setMatchupBytes(ByVal gamenum As Integer, ByVal home As Byte, ByVal away As Byte)
    schedule(gamenum * 2) = (home Or &H80)
    schedule((gamenum * 2) + 1) = (away Or &H80)
End Function

Public Function getNumberOfGames() As Long
    getNumberOfGames = (UBound(schedule) - 1) / 2
End Function

Public Function getWestAllStar(ByVal index As Integer) As Byte()
    Dim temp(1) As Byte
    temp(0) = west_allstars(0, index)
    temp(1) = west_allstars(1, index)
    getWestAllStar = temp
End Function
Public Function setWestAllStar(ByVal index As Integer, ByVal t As Byte, p As Byte)
    west_allstars(0, index) = t
    west_allstars(1, index) = p
End Function
Public Function getEastAllStar(ByVal index As Integer) As Byte()
    Dim temp(1) As Byte
    temp(0) = east_allstars(0, index)
    temp(1) = east_allstars(1, index)
    getEastAllStar = temp
End Function
Public Function setEastAllStar(ByVal index As Integer, ByVal t As Byte, p As Byte)
    east_allstars(0, index) = t
    east_allstars(1, index) = p
End Function











' 0=ok
' 1=unknown
' 2=rom type error
Public Function loadProjectFromRom(ByVal romType As Integer) As Integer
    Dim i As Integer, result As Integer, t As Integer, p As Integer
        Dim allstar_tempptr(23) As Long
        Dim temp_plyr As clsPlayer

    ' read teams
    For i = 0 To 26
        result = loadTeam(i, romType)
        If (result <> 0) Then
            Exit Function
        End If
    Next i
        
    ' read all-star data
    For p = 0 To 11
        '   player indexes (stats)
        west_allstars(0, p) = rom(ALLSTAR_PLYRINDEX + (p * 2)) / &H2
        west_allstars(1, p) = rom(ALLSTAR_PLYRINDEX + (p * 2) + 1) / &H2
        east_allstars(0, p) = rom(ALLSTAR_PLYRINDEX + (p * 2) + 24) / &H2
        east_allstars(1, p) = rom(ALLSTAR_PLYRINDEX + (p * 2) + 24 + 1) / &H2
    Next p

    ' read schedule
    For i = 0 To UBound(schedule)
        schedule(i) = rom(SCHEDULEDATA + i)
    Next i

End Function

' 0=ok
' 1=unknown error
' 2=abrev overran
' 3=city overran
' 4=mascot overran
' 5=player data overran
Public Function saveProjectToRom(ByVal romType As Integer) As Integer

    Dim t As Integer, p As Integer, i As Integer
    Dim as_plyr As clsPlayer
    Dim result As Integer
    Dim phys_addr As Long

    On Error GoTo err

    ' write team data
    result = writeAbrevStrings(romType)
    If (result = 2) Then
        saveProjectToRom = 2: Exit Function
    ElseIf (result <> 0) Then
        saveProjectToRom = 1: Exit Function
    End If

    result = writeCityStrings(romType)
    If (result = 2) Then
        saveProjectToRom = 3: Exit Function
    ElseIf (result <> 0) Then
        saveProjectToRom = 1: Exit Function
    End If

    result = writeMascotStrings(romType)
    If (result = 2) Then
        saveProjectToRom = 4: Exit Function
    ElseIf (result <> 0) Then
        saveProjectToRom = 1: Exit Function
    End If


    ' write player data
    result = writePlayerData(romType)
    If (result = 2) Then
        saveProjectToRom = 5: Exit Function
    ElseIf (result <> 0) Then
        saveProjectToRom = 1: Exit Function
    End If
    ' write player atts
    For t = 0 To 26
        For p = 0 To 11
            Call writePlayerAtts(t, p, romType)
        Next p
    Next t




    '   sim data
    For t = 0 To 26
        rom(SIMDATA + t) = team(t).getPointsScored()
        rom(SIMDATA + 27 + t) = team(t).getPointsGiven()
    Next t

    ' write all-star data
    For p = 0 To 11
        ' WEST
        Set as_plyr = team(west_allstars(0, p)).getPlayerRef(west_allstars(1, p))
        '   ptrs
        phys_addr = ALLSTAR_PTR + (p * 2)
        rom(phys_addr) = (as_plyr.getDataPtr() And &HFF)
        rom(phys_addr + 1) = ((as_plyr.getDataPtr() And &HFF00) / &H100&)
        '   team name index
        rom(ALLSTAR_TEAMINDEX + p) = west_allstars(0, p)
        '   player indexes (stats)
        rom(ALLSTAR_PLYRINDEX + (p * 2)) = (west_allstars(0, p) * 2)
        rom(ALLSTAR_PLYRINDEX + (p * 2) + 1) = (west_allstars(1, p) * 2)

        ' EAST
        Set as_plyr = team(east_allstars(0, p)).getPlayerRef(east_allstars(1, p))
        '   ptrs
        phys_addr = ALLSTAR_PTR + (p * 2) + 24
        rom(phys_addr) = (as_plyr.getDataPtr() And &HFF)
        rom(phys_addr + 1) = ((as_plyr.getDataPtr() And &HFF00) / &H100&)
        '   team name index
        rom(ALLSTAR_TEAMINDEX + p + 12) = east_allstars(0, p)
        '   player indexes (stats)
        rom(ALLSTAR_PLYRINDEX + (p * 2) + 24) = (east_allstars(0, p) * 2)
        rom(ALLSTAR_PLYRINDEX + (p * 2) + 24 + 1) = (east_allstars(1, p) * 2)
    Next p


    ' write schedule
    For i = 0 To UBound(schedule)
        rom(SCHEDULEDATA + i) = schedule(i)
    Next i

    ' uniform palettes
    Select Case (romType)
            Case ROM_NES:   For t = 0 To 26
                                rom(PALETTEDATA + t) = team(t).getUniformColor_NES_0()
                                rom(PALETTEDATA + 29 + t) = team(t).getUniformColor_NES_1()
                            Next t

            Case ROM_SNES:  For t = 0 To 26
                                phys_addr = PALETTEDATA + (t * &H100)
                                For i = 0 To 255
                                    rom(phys_addr + i) = team(t).getUniformData(i)
                                Next i
                            Next t

            Case Else:      saveProjectToRom = 1
                            Exit Function
    End Select

    saveProjectToRom = 0
    Exit Function
err:
    saveProjectToRom = 1
End Function














' loads a team from rom() in memory
' 0=ok
' 1=unknown
' 2=rom type error
Private Function loadTeam(ByVal team_index As Integer, ByVal romType As Integer) As Integer

    Dim teamptr As Long
    Dim i As Integer
    Dim phys_addr As Long
    Dim bank_start_city As Long, bank_start_mascot As Long, bank_start_abrev As Long
    

    'On Error GoTo err
    
    '---read in player data---

    teamptr = rom(TEAMDATAPTR + (team_index * 2))
    teamptr = teamptr + (rom(TEAMDATAPTR + (team_index * 2) + 1) * &H100&)
    For i = 0 To 11
        Call loadPlayer(team_index, i, teamptr, romType)
    Next i


    '---read in team data---

    ' set bank parameters
    Select Case (romType)
        Case ROM_NES:   bank_start_city = &H8000& + &H10&
                        bank_start_mascot = &H8000& + &H10&
                        bank_start_abrev = &HC000& + &H10&
        Case ROM_SNES:  bank_start_city = &H40000
                        bank_start_mascot = &H40000
                        bank_start_abrev = &H4000&
    End Select

    '    city name
    teamptr = rom(CITYNAMEPTR + (team_index * 2))
    teamptr = teamptr + (rom(CITYNAMEPTR + (team_index * 2) + 1) * &H100&)
    phys_addr = ((teamptr And &H3FFF) + bank_start_city)
    Call team(team_index).setCity(parseString(phys_addr))

    '    mascot name
    teamptr = rom(MASCOTNAMEPTR + (team_index * 2))
    teamptr = teamptr + (rom(MASCOTNAMEPTR + (team_index * 2) + 1) * &H100&)
    phys_addr = ((teamptr And &H3FFF) + bank_start_mascot)
    Call team(team_index).setMascot(parseString(phys_addr))

    '    abreviation name
    teamptr = rom(ABREVNAMEPTR + (team_index * 2))
    teamptr = teamptr + (rom(ABREVNAMEPTR + (team_index * 2) + 1) * &H100&)
    phys_addr = ((teamptr And &H3FFF) + bank_start_abrev)
    Call team(team_index).setAbrev(parseString(phys_addr))

    '   sim data
    Call team(team_index).setPointsScored(rom(SIMDATA + team_index))
    Call team(team_index).setPointsGiven(rom(SIMDATA + 27 + team_index))

    ' uniform palettes
    Select Case (romType)
        Case ROM_NES:   phys_addr = PALETTEDATA + team_index
                        Call team(team_index).setUniformColor_NES(rom(phys_addr), rom(phys_addr + 29))
                        team(team_index).uniformNES_vaild = True

        Case ROM_SNES:  phys_addr = PALETTEDATA + (team_index * &H100)
                        For i = 0 To 127
                            Call team(team_index).setUniformColor_2Bytes(i, rom(phys_addr + (i * 2)), rom(phys_addr + (i * 2) + 1))
                        Next i
                        team(team_index).uniformSNES_vaild = True

        Case Else:      loadTeam = 2
                        Exit Function
    End Select
    
    loadTeam = 0
    Exit Function

err:
    loadTeam = 1
End Function

Private Function loadPlayer(ByVal team_index As Integer, ByVal player_index As Integer, _
                            ByVal teamaddr As Long, _
                            ByVal romType As Integer)

    Dim phys_addr As Long
    Dim offset As Integer       ' offset into rom after phys_addr
    Dim player As clsPlayer
    
    Set player = team(team_index).getPlayerRef(player_index)
    
    ' -------------------------
    '  read in the player data
    ' -------------------------

    Dim playerptr As Long
    Dim stage As Integer        ' tracks what kind of data is being read in
    Dim fname As String, lname As String

    Select Case (romType)
        Case ROM_NES:   playerptr = rom(((teamaddr + &H10&) And &H3FFF&) + (player_index * 2) + &H8000&)
                        playerptr = playerptr + (rom(((teamaddr + &H10&) And &H3FFF) + (player_index * 2) + &H8001&) * &H100&)
                        phys_addr = ((playerptr And &H3FFF&) + &H8000& + &H10&)
        Case ROM_SNES:  playerptr = rom((teamaddr And &H7FFF&) + (player_index * 2) + &H40000)
                        playerptr = playerptr + (rom((teamaddr And &H7FFF) + (player_index * 2) + &H40001) * &H100&)
                        phys_addr = ((playerptr And &H7FFF&) + &H40000)
    End Select

    ' read name into player object
    offset = 0: stage = 0: fname = "": lname = ""
    Do
        If (rom(phys_addr + offset) >= &H80) Then
            Exit Do
        ElseIf (rom(phys_addr + offset) = &H20) Then
            stage = 1
            offset = offset + 1
        Else
            If (stage = 0) Then
                fname = fname + Chr(rom(phys_addr + offset))
            ElseIf (stage = 1) Then
                lname = lname + Chr(rom(phys_addr + offset))
            Else
                Exit Do
            End If
            offset = offset + 1
        End If
    Loop
    Call player.setFirst(fname)
    Call player.setLast(lname)

    ' read reast of data
    Call player.setPosition(rom(phys_addr + offset + 0) And &H7)                    ' position
    Call player.setJersey(str(Val(Hex(rom(phys_addr + offset + 1)))))               ' jersey #
    Call player.setFeet((rom(phys_addr + offset + 2) And &HF0) / &H10)              ' height (ft)
    Call player.setInch((rom(phys_addr + offset + 2) And &HF))                      '   "    (in)
    Call player.setWeight((rom(phys_addr + offset + 3) * 4))                        ' weight
    Call player.setFGpercent(Val("&H" & Hex(rom(phys_addr + offset + 4) * 4)))      ' FG%
    Call player.setFTpercent(Val("&H" & Hex(rom(phys_addr + offset + 5) * 4)))      ' FT%
    Call player.set3PTpercent(Val("&H" & Hex(rom(phys_addr + offset + 6) * 4)))     ' 3PT%
    
    ' -------------------
    '  read in the atts
    ' -------------------

    Select Case (romType)
        Case ROM_NES:    phys_addr = TEAMATTPTR + (team_index * 72) + (player_index * 6)
        Case ROM_SNES:   phys_addr = TEAMATTPTR + (team_index * 84) + (player_index * 7)
    End Select
    Call player.setRunSpeed(rom(phys_addr + 0))                 ' run speed
    Call player.setJump(rom(phys_addr + 1))                     ' jumping
    Call player.setShotRange(rom(phys_addr + 2))                ' race + shoot range
    Call player.setStamina(rom(phys_addr + 3))                  ' stamina
    Call player.setSteal(rom(phys_addr + 4))                    ' steal
    Call player.setBlock(rom(phys_addr + 5))                    ' face + block
    If (romType = ROM_SNES) Then
        Call player.setUnknownByte(rom(phys_addr + 6))          ' unknown byte
    End If

End Function

' convert from byte->string
Private Function parseString(ByVal addr As Long) As String
    Dim i As Integer
    For i = 0 To 255
        If (rom(addr + i) = &HFF) Then
            Exit For
        Else
            parseString = parseString + Chr(rom(addr + i))
        End If
    Next i
End Function















Private Function writePlayerAtts(ByVal team_index As Integer, ByVal player_index As Integer, _
                                 ByVal romType As Integer)
    Dim phys_addr As Long
    Dim player As clsPlayer
    
    Set player = team(team_index).getPlayerRef(player_index)
    Select Case (romType)
        Case ROM_NES:   phys_addr = TEAMATTPTR + (team_index * 72) + (player_index * 6)
        Case ROM_SNES:  phys_addr = TEAMATTPTR + (team_index * 84) + (player_index * 7)
    End Select
        
    rom(phys_addr + 0) = player.getRunSpeed()                                   ' run speed
    rom(phys_addr + 1) = player.getJump()                                       ' jumping
    rom(phys_addr + 2) = (player.getRaceNES() Or player.getShotRange())         ' race + shoot range
    rom(phys_addr + 3) = player.getStamina()                                    ' stamina
    rom(phys_addr + 4) = player.getSteal()                                      ' steal
    rom(phys_addr + 5) = (player.getFaceNES() Or player.getBlock())             ' face + block
    
    If (romType = ROM_SNES) Then
        rom(phys_addr + 6) = player.getUnknownByte()                            ' unknown byte
    End If
    
End Function


' RET:  0=ok
'       1=unknown
'       2=strings over ran bank
Private Function writeCityStrings(ByVal romType As Integer) As Integer
    On Error GoTo err

    Dim ptr_tbl(&H3A - 1) As Byte, data_array(&H103 - 1) As Byte
    Dim system_addr As Long, offset As Integer
    Dim s_index As Integer, c_index As Integer
    Dim outstring As String
    
    ' encode data and calculate pointers
    offset = 0
    For s_index = 0 To 28
        ' set address in pointer table
        Select Case (romType)
                Case ROM_NES:   system_addr = ((CITYNAMEDATA + offset) And &H3FFF) + &H8000& - &H10&
                Case ROM_SNES:  system_addr = ((CITYNAMEDATA + offset) And &H7FFF) + &H8000&
        End Select
        ptr_tbl(s_index * 2) = (system_addr And &HFF)
        ptr_tbl((s_index * 2) + 1) = ((system_addr And &HFF00) / &H100)
        
        ' get string
        If (s_index <= 26) Then
            outstring = team(s_index).getCity()
        ElseIf (s_index = 27) Then
            outstring = "WEST"
        Else
            outstring = "EAST"
        End If
        
        ' convert string->byte
        For c_index = 1 To Len(outstring)
            If (offset > UBound(data_array)) Then
                writeCityStrings = 2
                Exit Function
            Else
                data_array(offset) = Asc(Mid(outstring, c_index, 1))
            End If
            offset = offset + 1
        Next c_index
        ' write terminating "$FF"
        If (offset > UBound(data_array)) Then
            writeCityStrings = 2
            Exit Function
        Else
            data_array(offset) = &HFF
            offset = offset + 1
        End If
    Next s_index
    
    ' write data back to rom()
    Call writeArrayToRom(ptr_tbl, CITYNAMEPTR)
    Call writeArrayToRom(data_array, CITYNAMEDATA)
    
    writeCityStrings = 0
    Exit Function
err:
    writeCityStrings = 1
End Function

'       0=ok
'       1=unknown
'       2=strings over ran bank
Private Function writeMascotStrings(ByVal romType As Integer) As Integer
    On Error GoTo err

    Dim ptr_tbl(&H3A - 1) As Byte, data_array(&HDA - 1) As Byte
    Dim system_addr As Long, offset As Integer
    Dim s_index As Integer, c_index As Integer
    Dim outstring As String
    
    ' encode data and calculate pointers
    offset = 0
    For s_index = 0 To 28
        ' set address in pointer table
        Select Case (romType)
                Case ROM_NES:   system_addr = ((MASCOTNAMEDATA + offset) And &H3FFF) + &H8000& - &H10&
                Case ROM_SNES:  system_addr = ((MASCOTNAMEDATA + offset) And &H7FFF) + &H8000&
        End Select
        ptr_tbl(s_index * 2) = (system_addr And &HFF)
        ptr_tbl((s_index * 2) + 1) = ((system_addr And &HFF00) / &H100)
        
        ' get string
        If (s_index <= 26) Then
            outstring = team(s_index).getMascot()
        Else
            outstring = "ALL-STARS"                                         '  print "ALL-STARS" (for i=27 and i=28)
            ptr_tbl((s_index * 2) + 2) = ptr_tbl(s_index * 2)               '  write string only once
            ptr_tbl((s_index * 2) + 3) = ptr_tbl((s_index * 2) + 1)
            s_index = 28
        End If
        
        ' convert string->byte
        For c_index = 1 To Len(outstring)
            If (offset > UBound(data_array)) Then
                writeMascotStrings = 2
                Exit Function
            Else
                data_array(offset) = Asc(Mid(outstring, c_index, 1))
            End If
            offset = offset + 1
        Next c_index
        ' write terminating "$FF"
        If (offset > UBound(data_array)) Then
            writeMascotStrings = 2
            Exit Function
        Else
            data_array(offset) = &HFF
            offset = offset + 1
        End If
    Next s_index
    
    ' write data back to rom()
    Call writeArrayToRom(ptr_tbl, MASCOTNAMEPTR)
    Call writeArrayToRom(data_array, MASCOTNAMEDATA)
    
    writeMascotStrings = 0
    Exit Function
err:
    writeMascotStrings = 1
End Function

' RET:  0=ok
'       1=unknown
'       2=strings over ran bank
Private Function writeAbrevStrings(ByVal romType As Integer) As Integer
    On Error GoTo err

    Dim ptr_tbl(&H44 - 1) As Byte, data_array(&HAB - 1) As Byte
    Dim system_addr As Long, offset As Integer
    Dim s_index As Integer, c_index As Integer
    Dim outstring As String
    
    ' encode data and calculate pointers
    offset = 0
    For s_index = 0 To 33

        ' set address in pointer table
        Select Case (romType)
                Case ROM_NES:   system_addr = ((ABREVNAMEDATA + offset) And &H3FFF) + &H8000& - &H10&
                Case ROM_SNES:  system_addr = ((ABREVNAMEDATA + offset) And &H7FFF) + &H8000&
        End Select
        ptr_tbl(s_index * 2) = (system_addr And &HFF)
        ptr_tbl((s_index * 2) + 1) = ((system_addr And &HFF00) / &H100)
        
        ' get string
        If (s_index <= 26) Then
            outstring = team(s_index).getAbrev()
        Else
            Select Case (s_index)
                '  read playoffs/finals strings
                Case 27:    outstring = "1WC"
                Case 28:    outstring = "1EC"
                Case 29:    outstring = "2WC"
                Case 30:    outstring = "2EC"
                Case 31:    outstring = "WCF"
                Case 32:    outstring = "ECF"
                Case 33:    outstring = "NBAF"
            End Select
        End If
        
        ' convert string->byte
        For c_index = 1 To Len(outstring)
            If (offset > UBound(data_array)) Then
                writeAbrevStrings = 2
                Exit Function
            Else
                data_array(offset) = Asc(Mid(outstring, c_index, 1))
            End If
            offset = offset + 1
        Next c_index
        ' write terminating "$FF"
        If (offset > UBound(data_array)) Then
            writeAbrevStrings = 2
            Exit Function
        Else
            data_array(offset) = &HFF
            offset = offset + 1
        End If

    Next s_index
    
    ' write data back to rom()
    Call writeArrayToRom(ptr_tbl, ABREVNAMEPTR)
    Call writeArrayToRom(data_array, ABREVNAMEDATA)
    
    writeAbrevStrings = 0
    Exit Function
err:
    writeAbrevStrings = 1
End Function


'
'   block memory copy
'
Private Function writeArrayToRom(ByRef data() As Byte, ByVal phys_addr As Long)
    Dim i As Integer
    For i = 0 To UBound(data)
        rom(phys_addr + i) = data(i)
    Next i
End Function




























' INI:      TEAMPTR_ADDR    = 0x4138A   (SNES->$938A)
'           TEAMDATA_ADDR   = 0x4142C   (SNES->$942C)
'
' RET:      0=ok
'           1=unknown
'           2=strings overran bank
Private Function writePlayerData(ByVal romType As Integer) As Integer

    On Error GoTo err

    Dim ptr_tbl(&H36 - 1) As Byte, data_array(&H1B03 - 1) As Byte, exp_array(&H300 - 1) As Byte
    Dim player As clsPlayer, player_data() As Byte
    
    Dim system_addr As Long
    Dim data_offset As Long, ptr_offset As Long, zero_offset As Long
    Dim t_index As Integer, p_index As Integer, d_index As Integer  ' t=team, p=player, d=data

    ' encode data and calculate pointers
    data_offset = 0: ptr_offset = 0
    For t_index = 0 To 26
    
'Debug.Print t_index & vbTab & "addr=" & Hex(((TEAMDATAADDR + data_offset) And &H7FFF) + &H8000&)

        ' set address in team pointer table
        Select Case (romType)
            Case ROM_NES:   system_addr = ((TEAMDATAADDR + data_offset) And &H7FFF) + &H8000& - &H10&
            Case ROM_SNES:  system_addr = ((TEAMDATAADDR + data_offset) And &H7FFF) + &H8000&
        End Select
        ptr_tbl(t_index * 2) = (system_addr And &HFF)
        ptr_tbl((t_index * 2) + 1) = ((system_addr And &HFF00) / &H100)

        ptr_offset = data_offset        ' set start of player pointer table
        data_offset = ptr_offset + 24   ' set start of player data

        ' encode each player
        For p_index = 0 To 11

'Debug.Print p_index & vbTab & "addr=" & Hex(((TEAMDATAADDR + data_offset) And &H7FFF) + &H8000&)

            ' get data
            Set player = team(t_index).getPlayerRef(p_index)
            player_data = player.getDataArray()

            If ((data_offset + UBound(player_data)) <= UBound(data_array)) Then
            
                ' set address in player pointer table
                
                Select Case (romType)
                    Case ROM_NES:   system_addr = ((TEAMDATAADDR + data_offset) And &H7FFF) + &H8000& - &H10&
                    Case ROM_SNES:  system_addr = ((TEAMDATAADDR + data_offset) And &H7FFF) + &H8000&
                    Case Else:      writePlayerData = 1: Exit Function
                End Select
                data_array(ptr_offset) = (system_addr And &HFF)
                data_array(ptr_offset + 1) = ((system_addr And &HFF00) / &H100)
                ptr_offset = ptr_offset + 2
                
                Call player.setDataPtr(system_addr)
                
                ' write data
    
                For d_index = 0 To UBound(player_data)
                    If ((data_offset + d_index) > UBound(data_array)) Then
                        writePlayerData = 2
                        Exit Function
                    Else
                        data_array(data_offset + d_index) = player_data(d_index)
                    End If
                Next d_index
                data_offset = (data_offset + UBound(player_data) + 1)
                zero_offset = data_offset
            Else
                If (romType = ROM_SNES) Then

                    ' set address in player pointer table
                    system_addr = ((TEAMDATA_EXP - zero_offset + data_offset) And &H7FFF) + &H8000&
                    data_array(ptr_offset) = (system_addr And &HFF)
                    data_array(ptr_offset + 1) = ((system_addr And &HFF00) / &H100)
                    ptr_offset = ptr_offset + 2
                    
                    Call player.setDataPtr(system_addr)
                    
                    ' write data
                    For d_index = 0 To UBound(player_data)
                        If ((data_offset - zero_offset + d_index) > UBound(data_array)) Then
                            writePlayerData = 2
                            Exit Function
                        Else
                            exp_array(data_offset - zero_offset + d_index) = player_data(d_index)
                        End If
                    Next d_index
                    data_offset = (data_offset + UBound(player_data) + 1)
                Else
                    writePlayerData = 2
                    Exit Function
                End If
            
            End If

        Next p_index
    Next t_index

    ' write data back to rom()
    Call writeArrayToRom(ptr_tbl, TEAMDATAPTR)
    Call writeArrayToRom(data_array, TEAMDATAADDR)
    Select Case (romType)
        Case ROM_SNES:  Call writeArrayToRom(exp_array, TEAMDATA_EXP)
        Case Else:      ' do nothing
    End Select
    
    writePlayerData = 0
    Exit Function

err:
    writePlayerData = 1
End Function




'_________________________________________________________________________________________________________________
'
'   file i/o
'
'     formats:
'
'       -----------------
'        project (*.rpr)
'       -----------------
'        @SCHED
'            HEXSTRING
'        @END
'        @ALLSTAR
'            east=HEXSTRING
'            west=HEXSTRING
'        @END
'        @0
'            (team0 -> see *.rte format)
'        @END
'        ...
'        ...
'        @26
'            (team0 -> see *.rte format)
'        @END


Public Function exportProject(ByVal filename As String) As Integer
    On Error GoTo err

    Dim nFileNum As Integer, t As Integer, p As Integer
    nFileNum = FreeFile

    Open filename For Output As nFileNum
        Call writeToFile(nFileNum)
        For t = 0 To 26
            Print #nFileNum, "@" & t
            Call team(t).writeToFile(nFileNum)
            For p = 0 To 11
                Print #nFileNum, "#" & p
                Call team(t).getPlayerRef(p).writeToFile(nFileNum)
                Print #nFileNum, "#END"
            Next p
            Print #nFileNum, "@END"
        Next t
    Close nFileNum
        
    exportProject = 0
    Exit Function

err:
    exportProject = 1
    Close nFileNum
End Function

Private Function writeToFile(ByVal nFileNum As Integer)
    Dim outstring As String, i As Integer
    ' schedule
    Print #nFileNum, "@SCHED"
        outstring = ""
        For i = 0 To UBound(schedule)
            outstring = outstring & Right("00" & Hex(schedule(i)), 2)
        Next i
        Print #nFileNum, outstring
    Print #nFileNum, "@END"
    ' allstar data
    Print #nFileNum, "@ALLSTAR"
        Print #nFileNum, "east=" & getAllStar_String(0)
        Print #nFileNum, "west=" & getAllStar_String(1)
    Print #nFileNum, "@END"
End Function

Public Function importProject(ByVal filename As String) As Integer
    'On Error GoTo err
    
    Dim nFileNum As Integer, i As Integer, instring As String
    nFileNum = FreeFile
    
    Call initProject               ' reset project to defaults (in case of older version of *.rpr)
    Open filename For Input As nFileNum
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, instring
            Call processImportString(nFileNum, instring)
        Loop
    Close nFileNum

    importProject = 0
    Exit Function

err:
    importProject = 1
    Close nFileNum
End Function

Private Function processImportString(ByVal nFileNum As Integer, ByVal instring As String)
    Dim leaguestr As String, i As Integer
    Dim teaminstr As String, ptr As Long

    If (InStr(instring, "@SCHED") <> 0) Then
        ptr = 0
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, leaguestr
            If (leaguestr = "@END") Then
                Exit Do
            Else
                ' read data to array
                For i = 0 To (Len(leaguestr) / 2) - 1
                    schedule(ptr + i) = Val("&H" & Mid(leaguestr, 1 + (i * 2), 2))
                Next i
                ptr = ptr + i
                Debug.Print "ptr=" & Hex(ptr)
                Debug.Print Hex(schedule(ptr - 1))
            End If
        Loop
    ElseIf (InStr(instring, "@ALLSTAR") <> 0) Then
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, leaguestr
            If (leaguestr = "@END") Then
                Exit Do
            Else
                If (Left(leaguestr, 5) = "east=") Then
                    leaguestr = Right(leaguestr, Len(leaguestr) - 5)
                    For i = 0 To 11
                        east_allstars(0, i) = Val("&H" & Mid(leaguestr, i * 4 + 1, 2))
                        east_allstars(1, i) = Val("&H" & Mid(leaguestr, (i * 4) + 3, 2))
                    Next i
                ElseIf (Left(leaguestr, 5) = "west=") Then
                    leaguestr = Right(leaguestr, Len(leaguestr) - 5)
                    For i = 0 To 11
                        west_allstars(0, i) = Val("&H" & Mid(leaguestr, i * 4 + 1, 2))
                        west_allstars(1, i) = Val("&H" & Mid(leaguestr, (i * 4) + 3, 2))
                    Next i
                End If
            End If
        Loop
    ElseIf (InStr(instring, "@") <> 0) And (instring <> "@END") Then
        i = Val(Right(instring, Len(instring) - 1))
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, teaminstr
            If (teaminstr = "@END") Then
                Exit Do
            Else
                Call team(i).processImportString(nFileNum, teaminstr)
            End If
        Loop
    End If

End Function

Private Function initProject()
    Dim i As Integer
    ' init any project variables here
    Erase schedule
    Erase east_allstars
    Erase west_allstars
    For i = 0 To 26
        Call team(i).initTeam
    Next i
End Function

Private Function getAllStar_String(ByVal conf As Integer) As String
    Dim i As Integer
    conf = (conf And 1)
    For i = 0 To 11
        If (conf = 0) Then
            getAllStar_String = getAllStar_String & _
                Right("00" & Hex(east_allstars(0, i)), 2) & _
                Right("00" & Hex(east_allstars(1, i)), 2)
        Else
            getAllStar_String = getAllStar_String & _
                Right("00" & Hex(west_allstars(0, i)), 2) & _
                Right("00" & Hex(west_allstars(1, i)), 2)
        End If
    Next i
End Function









' thanks->http://en.wikipedia.org/wiki/Comb_sort
'
'function combsort(array input)
'       gap := input.size                                       //initialize gap size
'
'       loop until gap <= 1 or swaps = 0
'
'               if gap > 1                                      //update the gap value for a next comb
'                       gap := gap / 1.3
'                       if gap = 10 or gap = 9
'                               gap := 11
'                       end if
'               end if
'
'               i := 0
'               swaps := 0                                      //see bubblesort for an explanation
'
'               //a single "comb" over the input list
'               loop until i + gap >= array.size                //see shellsort for similar idea
'                       if array[i] > array[i+gap]
'                               swap(array[i], array[i+gap])
'                               swaps := 1                      // Arithmetic_overflow fixup
'                       end if
'                       i := i + 1
'               end loop
'       end loop
'end function


Public Function writeSortedList(ByVal filename As String, _
                                ByVal att As Integer, _
                                ByVal byposition As Boolean) As Integer

        On Error GoTo err
        
        Dim t As Integer, p As Integer, pos As Integer, player As clsPlayer
        Dim i As Long, gap As Long
        Dim nFileNum As Integer
        Dim sortedAtt((27 * 12) - 1) As Byte
        Dim sortedName((27 * 12) - 1) As String
        Dim sortedPos((27 * 12) - 1) As Byte
        
        Dim temp_byte As Byte, temp_str As String, temp_pos As Byte
        
        ' init data
        For t = 0 To 26
                For p = 0 To 11
                        Set player = team(t).getPlayerRef(p)
                        sortedAtt((t * 12) + p) = getAttForSort(player, att)
                        sortedName((t * 12) + p) = player.getFullname()
                        sortedPos((t * 12) + p) = player.getPosition()
                Next p
        Next t
        
        ' sort data
        gap = UBound(sortedAtt)                     ' initialize gap size
        Do Until (gap <= 1)
                ' update the gap value for a next comb
                If (gap > 1) Then
                        'Debug.Print "gap=" & gap & vbTab & "(gap / 1.3)=" & (gap / 1.3)
                        If (gap = 2) Then
                            gap = 1
                        Else
                            gap = gap / 1.3
                        End If
                        
                        If ((gap = 10) Or (gap = 9)) Then
                                gap = 11
                        End If
                End If
                i = 0
                ' a single "comb" over the input list
                Do Until ((i + gap) > UBound(sortedAtt))
                        If (sortedAtt(i) < sortedAtt(i + gap)) Then
                                temp_byte = sortedAtt(i)
                                    temp_str = sortedName(i)
                                    temp_pos = sortedPos(i)
                                sortedAtt(i) = sortedAtt(i + gap)
                                    sortedName(i) = sortedName(i + gap)
                                    sortedPos(i) = sortedPos(i + gap)
                                sortedAtt(i + gap) = temp_byte
                                    sortedName(i + gap) = temp_str
                                    sortedPos(i + gap) = temp_pos
                        End If
                        i = i + 1
                Loop
        Loop
        
        ' write data
        nFileNum = FreeFile
        Open filename For Output As nFileNum
            Print #nFileNum, getAttString(att) & vbNewLine
            
            If (byposition) Then

                For pos = 0 To 4
                    Select Case (pos)
                        Case 0: Print #nFileNum, "     Guards"
                        Case 1: Print #nFileNum, "     Guards"
                        Case 2: Print #nFileNum, "    Forwards"
                        Case 3: Print #nFileNum, "    Forwards"
                        Case 4: Print #nFileNum, "    Centers"
                    End Select
                    Print #nFileNum, "----------------"
                    For i = 0 To UBound(sortedAtt)
                        If (sortedPos(i) = pos) Then
                            Call writeSortedString(nFileNum, sortedName(i), sortedAtt(i))
                        End If
                    Next i
                    Print #nFileNum, vbNewLine & vbNewLine
                Next pos
            
            
            Else
                For i = 0 To UBound(sortedAtt)
                    Call writeSortedString(nFileNum, sortedName(i), sortedAtt(i))
                Next i
            End If
        Close nFileNum

        writeSortedList = 0
        Exit Function

err:
        writeSortedList = 1
        Close nFileNum
End Function

Private Function writeSortedString(ByVal nFileNum As Integer, ByVal name As String, ByVal att As Byte)
        If (Len(name) < 8) Then
            Print #nFileNum, name & vbTab & vbTab & vbTab & att
        ElseIf (Len(name) < 16) Then
            Print #nFileNum, name & vbTab & vbTab & att
        Else
            Print #nFileNum, name & vbTab & att
        End If
End Function

' this functions returns an attribyte byte based on the player passed in
'
' att:          0=RUN SPEED
'               1=JUMP
'               2=STEAL
'               3=BLOCK
'               4=SHOT RANGE
'               5=STAM
'
Private Function getAttForSort(ByVal player As clsPlayer, ByVal att As Integer) As Byte
        Select Case (att)
                Case 0: getAttForSort = player.getConvRunSpeed()
                Case 1: getAttForSort = player.getConvJump()
                Case 2: getAttForSort = player.getConvSteal()
                Case 3: getAttForSort = player.getConvBlock()
                Case 4: getAttForSort = player.getConvShotRange()
                Case 5: getAttForSort = player.getConvStamina()
        End Select
End Function

Private Function getAttString(ByVal att As Integer) As String
        Select Case (att)
                Case 0: getAttString = "Run Speed"
                Case 1: getAttString = "Jumping"
                Case 2: getAttString = "Stealing"
                Case 3: getAttString = "Blocking"
                Case 4: getAttString = "Shooting Range"
                Case 5: getAttString = "Stamina"
        End Select
End Function

