VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTeam"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private cityname As String              ' string data
Private mascotname As String
Private abrevname As String
Private pointsScored As Byte            ' sim data
Private pointsGiven As Byte
Private player(12) As New clsPlayer     ' player data

Public uniformNES_vaild As Boolean
Private uniformPalette_NES(1) As Byte
Public uniformSNES_vaild As Boolean
Private uniformPalette_SNES(&H100 - 1) As Byte

Option Explicit





Public Function setCity(ByVal city As String)
    cityname = city
End Function
Public Function setMascot(ByVal mascot As String)
    mascotname = mascot
End Function
Public Function setAbrev(ByVal abrev As String)
    abrevname = abrev
End Function
Public Function setPointsScored(ByVal points As Byte)
        pointsScored = points
End Function
Public Function setPointsGiven(ByVal points As Byte)
        pointsGiven = points
End Function

Public Function getCity() As String
    getCity = cityname
End Function
Public Function getMascot() As String
    getMascot = mascotname
End Function
Public Function getAbrev() As String
    getAbrev = abrevname
End Function
Public Function getPointsScored() As Byte
        getPointsScored = pointsScored
End Function
Public Function getPointsGiven() As Byte
        getPointsGiven = pointsGiven
End Function



'_________________________________________________________________________________________________________________




Public Function getPlayerRef(ByVal playernum As Integer) As clsPlayer
    Set getPlayerRef = player(playernum)
End Function
Public Function getPaletteRef(ByVal palType As Integer) As Byte()
    Select Case (palType)
        Case ROM_NES:   getPaletteRef = uniformPalette_NES
        Case ROM_SNES:  getPaletteRef = uniformPalette_SNES
        Case Else:      getPaletteRef = Null
    End Select
End Function





'
'_________________________________________________________________________________________________________________
'


' nes uniform functions
Public Function setUniformColor_NES(ByVal color0 As Byte, ByVal color1 As Byte)
    uniformNES_vaild = True
    uniformPalette_NES(0) = color0
    uniformPalette_NES(1) = color1
End Function
Public Function setUniformColor_NES_single(ByVal index As Integer, ByVal color As Byte)
    uniformNES_vaild = True
    uniformPalette_NES(index And 1) = (color And &H3F)
End Function

Public Function getUniformColor_NES() As Byte()
    Dim temp(1) As Byte
    temp(0) = uniformPalette_NES(0)
    temp(1) = uniformPalette_NES(1)
    getUniformColor_NES = temp
End Function
Public Function getUniformColor_NES_0() As Byte
    getUniformColor_NES_0 = uniformPalette_NES(0)
End Function
Public Function getUniformColor_NES_1() As Byte
    getUniformColor_NES_1 = uniformPalette_NES(1)
End Function
Public Function getUniformColor_NES_single(ByVal index As Integer)
    getUniformColor_NES_single = uniformPalette_NES(index And 1)
End Function

' snes uniform functions
Public Function setUniformColor_2Bytes(ByVal index As Integer, ByVal byte0 As Byte, ByVal byte1 As Byte)
    uniformSNES_vaild = True
    index = (index And &H7F)
    uniformPalette_SNES(index * 2) = byte0
    uniformPalette_SNES((index * 2) + 1) = byte1
End Function
Public Function setUniformColor_1Word(ByVal index As Integer, ByVal word0 As Integer)
    uniformSNES_vaild = True
    Call setUniformColor_2Bytes(index, (word0 And &HFF), ((word0 And &HFF00) / &H100))
End Function

Public Function getUniformColor_RGB(ByVal index As Integer) As Long
    Dim r As Integer, g As Integer, b As Integer, pal As Integer
    pal = getUniformColor_1Word(index)
    r = (pal And &H1F) * 8
    g = ((pal And &H3E0) / &H20) * 8
    b = ((pal And &H7C00) / &H400) * 8
    getUniformColor_RGB = RGB(r, g, b)
End Function
Public Function getUniformColor_1Word(ByVal index As Integer) As Integer
    index = (index And &H7F)
    getUniformColor_1Word = uniformPalette_SNES(index * 2) + (uniformPalette_SNES((index * 2) + 1) * &H100)
End Function
Public Function getUniformColor_2Bytes(ByVal index As Integer) As Byte()
    Dim temp(1) As Byte
    index = (index And &H7F)
    temp(0) = uniformPalette_SNES(index * 2)
    temp(1) = (uniformPalette_SNES((index * 2) + 1) * &H100)
    getUniformColor_2Bytes = temp
End Function
Public Function getUniformData(ByVal index As Integer) As Byte
    getUniformData = uniformPalette_SNES(index And &HFF)
End Function
Public Function getRed(ByVal index As Integer) As Byte
    Dim pal As Integer
    pal = getUniformColor_1Word(index)
    getRed = (pal And &H1F)
End Function
Public Function getGreen(ByVal index As Integer) As Byte
    Dim pal As Integer
    pal = getUniformColor_1Word(index)
    getGreen = ((pal And &H3E0) / &H20)
End Function
Public Function getBlue(ByVal index As Integer) As Byte
    Dim pal As Integer
    pal = getUniformColor_1Word(index)
    getBlue = ((pal And &H7C00) / &H400)
End Function

'
'_________________________________________________________________________________________________________________
'
'
'   file i/o
'
'     formats:
'
'       ------------------
'        team    (*.rte")
'       ------------------
'
'           cityname=STRING
'           mascotname=STRING
'           abrevname=STRING
'           ps=NUMBER
'           pg=NUMBER
'           unifpalnes=HEXSTRING
'           unifpalsnes0=HEXSTRING
'           unifpalsnes1=HEXSTRING
'           unifpalsnes2=HEXSTRING
'           unifpalsnes3=HEXSTRING
'           #0
'           [player(0)]         (NOTE: see *.rpl)
'           ...
'           ...
'           #11
'           [player(11)]
'           #END
'

Public Function exportTeam(ByVal filename As String) As Integer
    'On Error GoTo err

    Dim nFileNum As Integer, i As Integer
    nFileNum = FreeFile

    Open filename For Output As nFileNum
        Call writeToFile(nFileNum)
        For i = 0 To 11
            Print #nFileNum, "#" & i
            Call player(i).writeToFile(nFileNum)
            Print #nFileNum, "#END"
        Next i
    Close nFileNum

    exportTeam = 0
    Exit Function

err:
    exportTeam = 1
    Close nFileNum
End Function

Public Function writeToFile(ByVal nFileNum As Integer)
    Dim r As Integer, c As Integer, outstring As String
    
    ' data
    Print #nFileNum, "city=" & UCase(cityname)
    Print #nFileNum, "mascot=" & UCase(mascotname)
    Print #nFileNum, "abrev=" & UCase(abrevname)
    Print #nFileNum, "ps=" & pointsScored
    Print #nFileNum, "pg=" & pointsGiven
    
    ' nes palette
    Print #nFileNum, "unifnes=" & uniformNES_vaild
    Print #nFileNum, "unifpalnes=" & _
        Right("00" & Hex(uniformPalette_NES(0)), 2) & Right("00" & Hex(uniformPalette_NES(1)), 2)

    ' snes palette
    Print #nFileNum, "unifsnes=" & uniformSNES_vaild
    For r = 0 To 3
        outstring = ""
        For c = 0 To 63
            outstring = outstring & Right("00" & Hex(uniformPalette_SNES((r * 64) + c)), 2)
        Next c
        Print #nFileNum, "unifpalsnes" & r & "=" & outstring
    Next r
    
End Function

Public Function importTeam(ByVal filename As String) As Integer
    On Error GoTo err
    
    Dim nFileNum As Integer, i As Integer, instring As String
    nFileNum = FreeFile
    
    Call initTeam             ' reset player to defaults (in case of older version of *.rpl)
    Open filename For Input As nFileNum
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, instring
            Call processImportString(nFileNum, instring)
        Loop
    Close nFileNum

    importTeam = 0
    Exit Function

err:
    importTeam = 1
    Close nFileNum
End Function

Public Function processImportString(ByVal nFileNum As Integer, ByVal instring As String)

    Dim tag As String, hexstring As String

    If (InStr(instring, "city=") <> 0) Then
        cityname = UCase(Right(instring, Len(instring) - 5))
    ElseIf (InStr(instring, "mascot=") <> 0) Then
        mascotname = UCase(Right(instring, Len(instring) - 7))
    ElseIf (InStr(instring, "abrev=") <> 0) Then
        abrevname = UCase(Right(instring, Len(instring) - 6))
    ElseIf (InStr(instring, "ps=") <> 0) Then
        pointsScored = Val(Right(instring, Len(instring) - 3))
    ElseIf (InStr(instring, "pg=") <> 0) Then
        pointsGiven = Val(Right(instring, Len(instring) - 3))
    ElseIf (InStr(instring, "unifnes=") <> 0) Then
        uniformNES_vaild = Right(instring, Len(instring) - 8)
    ElseIf (InStr(instring, "unifsnes=") <> 0) Then
        uniformSNES_vaild = Right(instring, Len(instring) - 9)
    ElseIf (InStr(instring, "unifpal") <> 0) Then
        tag = Left(instring, InStr(instring, "="))
        hexstring = Right(instring, Len(instring) - InStr(instring, "="))
        Select Case (tag)
                Case "unifpalnes=":     Call processNESpal_import(hexstring)
                Case "unifpalsnes0=":   Call processSNESpal_import(0, hexstring)
                Case "unifpalsnes1=":   Call processSNESpal_import(1, hexstring)
                Case "unifpalsnes2=":   Call processSNESpal_import(2, hexstring)
                Case "unifpalsnes3=":   Call processSNESpal_import(3, hexstring)
        End Select
   
    ElseIf (InStr(instring, "#") <> 0) And (instring <> "#END") Then
        Dim plyrinstr As String, i As Integer
        i = Val(Right(instring, Len(instring) - 1))
        Do While Not EOF(nFileNum)
            Line Input #nFileNum, plyrinstr
            If (plyrinstr = "#END") Then
                Exit Do
            Else
                Call player(i).processImportString(plyrinstr)
            End If
        Loop
    End If

End Function

Private Function processNESpal_import(ByVal hexstr As String)
        Dim i As Integer
        For i = 0 To 1
                uniformPalette_NES(i) = Val("&H" & Mid(hexstr, (i * 2) + 1, (i * 2) + 2))
        Next i
End Function
Private Function processSNESpal_import(ByVal palindex As Integer, hexstr As String)
        Dim start As Integer, i As Integer
        start = (palindex * 64)
        For i = 0 To 63
                uniformPalette_SNES(start + i) = Val("&H" & Mid(hexstr, (i * 2) + 1, 2))
        Next i
End Function

Public Function initTeam()
    Dim i As Integer
    cityname = "CITY"
    mascotname = "MASCOT"
    abrevname = "ABREV"
    pointsScored = &H64           ' 100
    pointsGiven = &H64            ' 100
    uniformNES_vaild = False
    Erase uniformPalette_NES
    uniformSNES_vaild = False
    Erase uniformPalette_SNES
    For i = 0 To 11
        Call player(i).initPlayer
    Next i
    
End Function
