Attribute VB_Name = "modGlobals"
' Windows API declarations
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, _
    ByVal nX As Long, _
    ByVal nY As Long, _
    ByVal crColor As Long) As Long

Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, _
    ByVal nX As Long, _
    ByVal nY As Long) As Long

Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, _
    ByVal nX As Long, _
    ByVal nY As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal xSrc As Long, _
    ByVal ySrc As Long, _
    ByVal nSrcWidth As Long, _
    ByVal nSrcHeight As Long, _
    ByVal dwRop As Long) As Long
    
'Constants used by the BitBlt Function
Public Const SRCAND = &H8800C6
Public Const SRCCOPY = &HCC0020
Public Const SRCERASE = &H440328
Public Const SRCINVERT = &H660046
Public Const SRCPAINT = &HEE0086

Public rom() As Byte
Public rom_length As Long
Public projectFile As New clsProject

Public Const PROGRAMNAME = "Rabbit v0.21.0"
Public Const DLGFILEFILTER = "All Supported Types|*.nes;*.smc|" & "NES Rom (*.nes)|*.nes|" & "SNES Rom (*.smc)|*.smc|"
Public Const DLGFILTER_PROJECT = "Rabbit Project File (*.rpr)| *.rpr"
Public Const DLGFILTER_TEAM = "Rabbit Team File (*.rte)| *.rte"
Public Const DLGFILTER_PLAYER = "Rabbit Player File (*.rpl)| *.rpl"
Public Const DLGFILTER_ANALYSIS = "Text File (*.txt)| *.txt"

Public Const INI_FILE = "rabbit.ini"
Public Const CARTINFO_ADDR = &H7FC0&

Public Const ROM_NONE = 0
Public Const ROM_NES = 1
Public Const ROM_SNES = 2
Public Const ROM_BOTH = 3       ' gui stuff mostly

' *.ini varialbes
Public LASTDIR As String
Public TEAMDATAPTR As Long
Public TEAMDATAADDR As Long
Public TEAMDATA_EXP As Long     ' points to expansion area for overflow of team data
Public TEAMATTPTR As Long
Public CITYNAMEPTR As Long
Public CITYNAMEDATA As Long
Public MASCOTNAMEPTR As Long
Public MASCOTNAMEDATA As Long
Public ABREVNAMEPTR As Long
Public ABREVNAMEDATA As Long
Public SCHEDULEDATA As Long
Public SIMDATA As Long
Public PALETTEDATA As Long
Public ALLSTAR_PTR As Long
Public ALLSTAR_TEAMINDEX As Long
Public ALLSTAR_PLYRINDEX As Long
' nes
Public nes_teamdata_ptr As Long
Public nes_teamdata_addr As Long
Public nes_teamdata_exp As Long
Public nes_teamatt_addr As Long
Public nes_cityname_ptr As Long
Public nes_cityname_data As Long
Public nes_mascotname_ptr As Long
Public nes_mascotname_data As Long
Public nes_abrevname_ptr As Long
Public nes_abrevname_data As Long
Public nes_schedule_data As Long
Public nes_sim_data As Long
Public nes_uniformpalette_data As Long
Public nes_allstar_ptrs As Long
Public nes_allstar_teamIndex As Long
Public nes_allstar_plyrIndex As Long
' snes
Public snes_teamdata_ptr As Long
Public snes_teamdata_addr As Long
Public snes_teamdata_exp As Long
Public snes_teamatt_addr As Long
Public snes_cityname_ptr As Long
Public snes_cityname_data As Long
Public snes_mascotname_ptr As Long
Public snes_mascotname_data As Long
Public snes_abrevname_ptr As Long
Public snes_abrevname_data As Long
Public snes_schedule_data As Long
Public snes_sim_data As Long
Public snes_uniformpalette_data As Long
Public snes_allstar_ptrs As Long
Public snes_allstar_teamIndex As Long
Public snes_allstar_plyrIndex As Long

'   formats:
'
'   ------------
'    rabbit.ini
'   ------------
'
'
'

Option Explicit

' read *.ini from disk
Public Function loadINI() As Boolean

    On Error GoTo err:
    Dim result As Integer, nFileNum As Integer
    Dim inline As String, tempstring As String

    nFileNum = FreeFile
    Open App.Path + "\" + INI_FILE For Input As #nFileNum
        'general
        Line Input #nFileNum, LASTDIR
        ' nes
        Line Input #nFileNum, tempstring: nes_teamdata_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_teamdata_addr = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_teamdata_exp = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_teamatt_addr = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_cityname_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_cityname_data = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_mascotname_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_mascotname_data = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_abrevname_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_abrevname_data = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_schedule_data = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_sim_data = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_uniformpalette_data = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_allstar_ptrs = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_allstar_teamIndex = Val(tempstring)
        Line Input #nFileNum, tempstring: nes_allstar_plyrIndex = Val(tempstring)
        ' snes
        Line Input #nFileNum, tempstring: snes_teamdata_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_teamdata_addr = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_teamdata_exp = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_teamatt_addr = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_cityname_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_cityname_data = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_mascotname_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_mascotname_data = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_abrevname_ptr = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_abrevname_data = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_schedule_data = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_sim_data = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_uniformpalette_data = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_allstar_ptrs = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_allstar_teamIndex = Val(tempstring)
        Line Input #nFileNum, tempstring: snes_allstar_plyrIndex = Val(tempstring)
    Close nFileNum
    Exit Function

err:
    Close nFileNum
    result = MsgBox("Error loading rabbit.ini! Create a default rabbit.ini file?", vbYesNo + vbExclamation, PROGRAMNAME)
    If result = 6 Then      ' yes
        Call initINI
        Call saveINI
    Else                    ' no
        Call initINI
    End If

End Function

' write *.ini to disk
Public Function saveINI() As Boolean

    On Error GoTo err

    Dim nFileNum As Integer
    nFileNum = FreeFile
    Open App.Path + "\" + INI_FILE For Output As nFileNum
        ' general
        Print #nFileNum, LASTDIR
        ' nes
        Print #nFileNum, nes_teamdata_ptr
        Print #nFileNum, nes_teamdata_addr
        Print #nFileNum, nes_teamdata_exp
        Print #nFileNum, nes_teamatt_addr
        Print #nFileNum, nes_cityname_ptr
        Print #nFileNum, nes_cityname_data
        Print #nFileNum, nes_mascotname_ptr
        Print #nFileNum, nes_mascotname_data
        Print #nFileNum, nes_abrevname_ptr
        Print #nFileNum, nes_abrevname_data
        Print #nFileNum, nes_schedule_data
        Print #nFileNum, nes_sim_data
        Print #nFileNum, nes_uniformpalette_data
        Print #nFileNum, nes_allstar_ptrs
        Print #nFileNum, nes_allstar_teamIndex
        Print #nFileNum, nes_allstar_plyrIndex
        ' snes
        Print #nFileNum, snes_teamdata_ptr
        Print #nFileNum, snes_teamdata_addr
        Print #nFileNum, snes_teamdata_exp
        Print #nFileNum, snes_teamatt_addr
        Print #nFileNum, snes_cityname_ptr
        Print #nFileNum, snes_cityname_data
        Print #nFileNum, snes_mascotname_ptr
        Print #nFileNum, snes_mascotname_data
        Print #nFileNum, snes_abrevname_ptr
        Print #nFileNum, snes_abrevname_data
        Print #nFileNum, snes_schedule_data
        Print #nFileNum, snes_sim_data
        Print #nFileNum, snes_uniformpalette_data
        Print #nFileNum, snes_allstar_ptrs
        Print #nFileNum, snes_allstar_teamIndex
        Print #nFileNum, snes_allstar_plyrIndex
    Close nFileNum
    
    Exit Function
    
err:
    MsgBox "Unable to save rabbit.ini.", vbOKOnly + vbExclamation, PROGRAMNAME

End Function

' load default *.ini settings
Public Function initINI()
        ' general
        LASTDIR = App.Path
        ' nes
        nes_teamdata_ptr = &H8011&
        nes_teamdata_addr = &H807B&
        nes_teamdata_exp = -1
        nes_teamatt_addr = &H9E99&
        nes_cityname_ptr = &H9B7E&
        nes_cityname_data = &H9BB8&
        nes_mascotname_ptr = &H9CBB&
        nes_mascotname_data = &H9CF5&
        nes_abrevname_ptr = &HE440&
        nes_abrevname_data = &HE395&
        nes_schedule_data = &HF53F&
        nes_sim_data = &HEA2E&
        nes_uniformpalette_data = &H1DC0C
        nes_allstar_ptrs = &H804B&
        nes_allstar_teamIndex = &HCE31&
        nes_allstar_plyrIndex = &HAA68&
        ' snes
        snes_teamdata_ptr = &H4138A
        snes_teamdata_addr = &H4142C
        snes_teamdata_exp = &H47CD0
        snes_teamatt_addr = &H43263
        snes_cityname_ptr = &H42F30
        snes_cityname_data = &H42F6A
        snes_mascotname_ptr = &H4306D
        snes_mascotname_data = &H430A7
        snes_abrevname_ptr = &H5B60&
        snes_abrevname_data = &H5AB5&
        snes_schedule_data = &H43B3F
        snes_sim_data = &H468E7
        snes_uniformpalette_data = &H4E000
        snes_allstar_ptrs = &H413C4
        snes_allstar_teamIndex = &H4925&
        snes_allstar_plyrIndex = &H40670
End Function

' read rom image from disk
'   0=good
'   1=i/o error
'   2=bad rom image
Public Function loadRom(ByVal filename As String, ByVal romType As Integer) As Integer

    On Error GoTo err

    Dim nFileNum As Integer
    nFileNum = FreeFile

    Open filename For Binary As nFileNum
    
        rom_length = LOF(1)
        ReDim rom(rom_length - 1)
        Get #nFileNum, &H1&, rom
    
    Close nFileNum
    
    If (Not validateRom(romType)) Then
        loadRom = 2
    Else
        loadRom = 0
        setRomPointers (romType)
    End If

    Exit Function

err:
    loadRom = 1

End Function

' write rom image to disk
Public Function saveRom(ByVal filename As String) As Integer

    On Error GoTo err

    Dim nFileNum As Integer
    nFileNum = FreeFile

    Open filename For Binary As nFileNum
        Put #nFileNum, &H1&, rom
    Close nFileNum

    saveRom = 0
    Exit Function

err:
    saveRom = 1

End Function

' validate the cart info
'
'     NES rom:  check for "NES" in header.
'     SNES rom: check for "SUPER NBA BASKETBALL" in rom info.
'
Public Function validateRom(ByVal romType As Integer) As Boolean
    Dim i As Integer, romname As String
    If (romType = ROM_NES) Then
        If ((rom(0) = &H4E) And (rom(1) = &H45) And (rom(2) = &H53)) Then
            validateRom = True
        Else
            validateRom = False
        End If
    ElseIf (romType = ROM_SNES) Then
        For i = 0 To 19
            romname = romname + Chr(rom(CARTINFO_ADDR + i))
        Next i
        If (romname = "SUPER NBA BASKETBALL") Then
            validateRom = True
        Else
            validateRom = False
        End If
    Else
        validateRom = False
    End If
    
End Function

' make sure the path is valid system directory
Public Function CheckPath(ByVal strPath As String) As Boolean
    On Error GoTo err
    If Dir$(strPath) <> "" Then
        CheckPath = True
    Else
err:
        CheckPath = False
    End If
End Function

Public Function setRomPointers(ByVal romType As Integer)
    Select Case (romType)
        Case ROM_NES:   TEAMDATAPTR = nes_teamdata_ptr
                        TEAMDATAADDR = nes_teamdata_addr
                        TEAMDATA_EXP = nes_teamdata_exp
                        TEAMATTPTR = nes_teamatt_addr
                        CITYNAMEPTR = nes_cityname_ptr
                        CITYNAMEDATA = nes_cityname_data
                        MASCOTNAMEPTR = nes_mascotname_ptr
                        MASCOTNAMEDATA = nes_mascotname_data
                        ABREVNAMEPTR = nes_abrevname_ptr
                        ABREVNAMEDATA = nes_abrevname_data
                        SCHEDULEDATA = nes_schedule_data
                        SIMDATA = nes_sim_data
                        PALETTEDATA = nes_uniformpalette_data
                        ALLSTAR_PTR = nes_allstar_ptrs
                        ALLSTAR_TEAMINDEX = nes_allstar_teamIndex
                        ALLSTAR_PLYRINDEX = nes_allstar_plyrIndex

        Case ROM_SNES:  TEAMDATAPTR = snes_teamdata_ptr
                        TEAMDATAADDR = snes_teamdata_addr
                        TEAMDATA_EXP = snes_teamdata_exp
                        TEAMATTPTR = snes_teamatt_addr
                        CITYNAMEPTR = snes_cityname_ptr
                        CITYNAMEDATA = snes_cityname_data
                        MASCOTNAMEPTR = snes_mascotname_ptr
                        MASCOTNAMEDATA = snes_mascotname_data
                        ABREVNAMEPTR = snes_abrevname_ptr
                        ABREVNAMEDATA = snes_abrevname_data
                        SCHEDULEDATA = snes_schedule_data
                        SIMDATA = snes_sim_data
                        PALETTEDATA = snes_uniformpalette_data
                        ALLSTAR_PTR = snes_allstar_ptrs
                        ALLSTAR_TEAMINDEX = snes_allstar_teamIndex
                        ALLSTAR_PLYRINDEX = snes_allstar_plyrIndex

    End Select
End Function
