' thanks->http://en.wikipedia.org/wiki/Comb_sort
'
'function combsort(array input)
'	gap := input.size					//initialize gap size
'    
'	loop until gap <= 1 or swaps = 0
'
'		if gap > 1					//update the gap value for a next comb
'			gap := gap / 1.3
'			if gap = 10 or gap = 9
'				gap := 11
'			end if
'		end if
'
'		i := 0
'		swaps := 0					//see bubblesort for an explanation
'
'		//a single "comb" over the input list
'		loop until i + gap >= array.size		//see shellsort for similar idea
'			if array[i] > array[i+gap]
'				swap(array[i], array[i+gap])
'				swaps := 1			// Arithmetic_overflow fixup
'			end if
'			i := i + 1
'		end loop
'	end loop
'end function


private function writeSortedList(byval filename as string, byval att as integer)

	on error goto err
	
	dim t as integer, p as integer, player as clsPlayer
	dim i as long, gap as long, swaps as long
	dim nFileNum as integer
	dim sortedAtt((27 * 12) - 1) as byte
	dim sortedName((27 * 12) - 1) as string
	
	dim temp_byte as byte, temp_str as string
	
	' init data
	for t = 0 to 26
		for p = 0 to 11
			set player = team(t).getPlayerRef(p)
			sortedAtt((t * 27) + p) = getAttForSort(player, att)
			sortedName((t * 27) + p) = player.getFullname()
		next p
	next t
	
	' sort data
	gap = ubound(sortedAtt)				' initialize gap size
	do until ((gap <= 1) or (swaps = 0))
		' update the gap value for a next comb
		if (gap > 1) then
			gap = (gap / 1.3)
			if ((gap = 10) or (gap = 9)) then
				gap = 11
			end if
		end if
		i = 0
		swaps = 0
		' a single "comb" over the input list
		do until ((i + gap) >= ubound(sortedAtt))
			if (sortedAtt(i) > sortedAtt(i + gap)) then
				temp_byte = sortedAtt(i)
				temp_str = sortedName(i)
				sortedAtt(i) = sortedAtt(i + gap)
				sortedName(i) = sortedName(i + gap)
				sortedAtt(i + gap) = temp_byte
				sortedName(i + gap) = temp_str
				swaps = 1
			end if
			i = i + 1
		loop
	loop
	
	' write data
	nFileNum = FreeFile
	Open filename For Output As nFileNum
		for i = 0 to ubound(sortedAtt)
			print #1, sortedName(i) & vbtab & vbtab & sortedAtt(i)
		next i
	Close nFileNum

	writeSortedList = 0
	exit function

err:
	writeSortedList = 1

end function

' this functions returns an attribyte byte based on the player index passed in
'
'  args:
' -------
' player(word):	$ttpp
'		 ||++-player index (0-11)
'		 ++---team index   (0-26)
'
' att:		0=RUN SPEED
'		1=JUMP
'		2=STEAL
'		3=BLOCK
'		4=SHOT RANGE
'		5=STAM
'
private function getAttForSort(byval player as clsPlayer, byval att as integer) as byte
	select case (att)
		case 0:	getAttForSort = player.getRunSpeed()
		case 1: getAttForSort = player.getJump()
		case 2: getAttForSort = player.getSteal()
		case 3: getAttForSort = player.getBlock()
		case 4: getAttForSort = player.getShotRange()
		case 5: getAttForSort = player.getStamina()
	end select
end function
